#include <jni.h>
#include <Cocoa/Cocoa.h>
#include "iTunes.h"

iTunesApplication *iTunes;

BOOL iTunesRunning() {
	BOOL run = NO;
	/*BOOL done = NO;
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	[NSRunLoop currentRunLoop];
	
	run = [iTunes isRunning];
	
	do {
        SInt32 result = CFRunLoopRunInMode(kCFRunLoopDefaultMode, 1, YES);
        if ((result == kCFRunLoopRunStopped) || (result == kCFRunLoopRunFinished)) {
			done = YES;
        }
	} while (!done);	
	
	[pool release];*/
	
	
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	run = [iTunes isRunning];
	
	[pool drain];
	
	return run;
}

JNIEXPORT jboolean JNICALL Java_fr_emn_osx_OSXiTunesControl_startup(JNIEnv *env, jclass cl) {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    
	iTunes = [SBApplication applicationWithBundleIdentifier:@"com.apple.iTunes"];
	
	[pool drain];
	
	if (iTunes != NULL)
		return TRUE;
	else
		return FALSE;
}

/*
** Shut down: release our data.
*/
JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_shutdown(JNIEnv *env, jclass cl) {
	
}

JNIEXPORT jboolean JNICALL Java_fr_emn_osx_OSXiTunesControl_isRunning (JNIEnv *env, jclass cl) {
	return iTunesRunning();
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_run (JNIEnv *env, jclass cl) {

	if ( !iTunesRunning() ) {
		[iTunes run];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_quit (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes quit];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_backTrack (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes backTrack];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_fastForward (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes fastForward];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_nextTrack (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes nextTrack];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_pause (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes pause];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_playOnce (JNIEnv *env, jclass cl, jboolean once) {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	if ( iTunesRunning() ) {
		[iTunes playOnce:once];
	}
	[pool drain];
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_playpause (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes playpause];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_previousTrack (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes previousTrack];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_resume (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes resume];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_rewind (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes rewind];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_stop (JNIEnv *env, jclass cl) {
	if ( iTunesRunning() ) {
		[iTunes stop];
	}
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_mute (JNIEnv *env, jclass cl, jboolean mute) {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	if ( iTunesRunning() ) {
		iTunes.mute = mute;
	}
	[pool drain];
}

JNIEXPORT void JNICALL Java_fr_emn_osx_OSXiTunesControl_soundVolume (JNIEnv *env, jclass cl, jint volume) {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];	
	if ( iTunesRunning() ) {
		if (volume >=0 && volume <= 100)
			iTunes.soundVolume = volume;
	}
	[pool drain];
}

JNIEXPORT jint JNICALL Java_fr_emn_osx_OSXiTunesControl_getSoundVolume (JNIEnv *env, jclass cl) {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	int ret = -1;
	
	if ( iTunesRunning() ) {
		ret = iTunes.soundVolume;
	}
	
	[pool drain];
	return ret;
}
