package fr.lri.insitu.FlowStates.examples.graphicalEditor;

import java.awt.geom.Point2D;

import fr.lri.insitu.FlowStates.examples.graphicalEditor.events.ResetZoom;
import fr.lri.insitu.FlowStates.examples.graphicalEditor.events.Zoom;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;
import fr.lri.insitu.FlowStates.transitions.Switch;
import fr.lri.insitu.FlowStates.transitions.SwitchOnPosition;
import fr.lri.swingstates.sm.State;
import fr.lri.swingstates.sm.Transition;
import fr.lri.swingstates.sm.transitions.EventOnPosition;

public class ZoomInteraction extends IConStateMachine {
	
	protected Point2D zoomCenter;
	
	public ZoomInteraction(String name, ZoomableCanvas c) {
		super(name, c);
	}

	State noZooming = new State() {
		
		Transition startZoom = new SwitchOnPosition(Zoom.class, SWITCH_ON, ">> zooming") {
			public void action() {
				zoomCenter = getPoint();
			}
		};
		Transition resetZoom = new Switch(ResetZoom.class, SWITCH_ON) {
			public void action() {
				((ZoomableCanvas)getCanvas()).resetZoom();
			}
		};
		
	};
	
	State zooming = new State() {
		Transition stopZoom = new SwitchOnPosition(Zoom.class, SWITCH_OFF, ">> noZooming") { };
		Transition zoomStep = new EventOnPosition(Zoom.class) {
			public void action() {
				double zoomFactor = ((Zoom)getEvent()).getSlotZoomFactor();
				if(zoomFactor != 0) {
					((ZoomableCanvas)getCanvas()).zoomBy(
							getPoint(), 
//							1+1/(10*deltaZ));
							zoomFactor);
				}
			}
		};
		
	};
	
}
