package fr.lri.insitu.FlowStates.examples.graphicalEditor2;

import java.awt.geom.Point2D;

import javax.swing.JFrame;

import fr.lri.insitu.FlowStates.IConEnvironnement;
import fr.lri.insitu.FlowStates.examples.graphicalEditor.Palette;
import fr.lri.insitu.FlowStates.examples.graphicalEditor.ZoomableCanvas;
import fr.lri.insitu.FlowStates.examples.menus.GenericTrackingMenu;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;

public class MainGraphicalEditor {

	public static void main(String[] args) {
		ZoomableCanvas canvas = new ZoomableCanvas(600, 400);
		
		/*canvas.newRectangle(new Point2D.Double(20, 20), 30, 40);
		canvas.newRectangle(new Point2D.Double(200, 200), 60, 40);
		canvas.newRectangle(new Point2D.Double(20, 200), 30, 40);
		canvas.newRectangle(new Point2D.Double(200, 20), 30, 40);*/
		new Palette(canvas);
		
		JFrame frame = new JFrame();
		//IConStateMachine smZUI = new ZUINavigation("zui", canvas);
		IConStateMachine pan = new PanInteraction("pan", canvas);
		IConStateMachine zoom = new ZoomInteraction("zoom", canvas);
		final Palette palette = new Palette(canvas);
		
		IConEnvironnement.addStateMachine(palette.getInteractionPalette(), frame, canvas);
		IConEnvironnement.addStateMachine(palette.getInteractionToolglass(), frame, canvas);
		
		//TrackingMenu trackingMenu = new TrackingMenu(canvas, frame, 60, 20, new String[] {"pan", "zoom", "pan", "zoom"});
		//IConEnvironnement.addStateMachine(trackingMenu.getInteraction(), frame, canvas);
		GenericTrackingMenu trackingMenu = new GenericTrackingMenu(canvas, frame, 60, 20, new String[] {"pan", "zoom", "pan", "zoom"});
		
		canvas.setAntialiased(true);
		IConEnvironnement.addStateMachine(new ZUIAdapter("ZUIadapter", canvas), frame, canvas);
		
		// either directly listening the machine
//		trackingMenu.getInteraction().addStateMachineListener(zoom);
		
		// or connecting using inputConfigurator
		//IConEnvironnement.addStateMachine(smZUI, frame, canvas);
		IConEnvironnement.addStateMachine(pan, frame, canvas);
		IConEnvironnement.addStateMachine(zoom, frame, canvas);
		
		frame.getContentPane().add(canvas);
		frame.pack();
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		canvas.requestFocus();
		
		IConEnvironnement.start("IC files/graphical-editor-pan-zoom.ic");
	}
	
}

