package fr.lri.insitu.FlowStates.examples.graphicalEditor2;

import java.awt.geom.Point2D;

import fr.lri.insitu.FlowStates.events.OutSlotEvent;
import fr.lri.insitu.FlowStates.examples.graphicalEditor.ZoomableCanvas;
import fr.lri.insitu.FlowStates.examples.menus.events.CommandMove;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;
import fr.lri.swingstates.sm.State;
import fr.lri.swingstates.sm.Transition;
import fr.lri.swingstates.sm.transitions.EventOnPosition;

public class ZUIAdapter extends IConStateMachine {

	public ZUIAdapter (String name, ZoomableCanvas c) {
		super(name, c);
	}

	public Class<? extends OutSlotEvent>[] getOutputTypes() {
		return new Class[] {Pan.class, Zoom.class};
	}
	
	State idle = new State() {
		
		
		Transition comEvent = new EventOnPosition(CommandMove.class) {
			public void action() {
				double zoomMin = 0.01;
				double deltaZ = Math.pow(zoomMin, 1.0/getCanvas().getHeight());
				
				CommandMove event = (CommandMove)getEvent();
				if (event.getSlotCommand().equals("zoom")) {
					Zoom zEvent = new Zoom();
					zEvent.setSlotX(event.getSlotX());
					zEvent.setSlotY(event.getSlotY());
					double deltaY = event.getSlotDeltaY();
					zEvent.setSlotX(event.getSlotStartX());
					zEvent.setSlotY(event.getSlotStartY());
					if(deltaY > 0)
						zEvent.setSlotdZ(Math.pow(deltaZ, deltaY));
					else
						zEvent.setSlotdZ(1.0/Math.pow(deltaZ, -deltaY));
					fireEvent(zEvent);
				} else if (event.getSlotCommand().equals("pan")) {
					Pan pEvent = new Pan();
					pEvent.setSlotDeltaX((int)event.getSlotDeltaX());
					pEvent.setSlotDeltaY((int)event.getSlotDeltaY());
					fireEvent(pEvent);
				}
			}
		};
	};

}
