package fr.lri.insitu.FlowStates.examples.menus;

import java.awt.geom.Point2D;

import javax.swing.JFrame;

import fr.lri.insitu.FlowStates.IConEnvironnement;
import fr.lri.insitu.FlowStates.events.OutSlotEvent;
import fr.lri.insitu.FlowStates.examples.menus.events.CommandMove;
import fr.lri.insitu.FlowStates.examples.menus.events.Control;
import fr.lri.insitu.FlowStates.examples.menus.events.InRange;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;
import fr.lri.insitu.FlowStates.transitions.Switch;
import fr.lri.insitu.FlowStates.transitions.SwitchOnPosition;
import fr.lri.insitu.FlowStates.transitions.SwitchOnTag;
import fr.lri.swingstates.canvas.Canvas;
import fr.lri.swingstates.canvas.transitions.EventOnTag;
import fr.lri.swingstates.sm.State;
import fr.lri.swingstates.sm.Transition;
import fr.lri.swingstates.sm.transitions.EventOnPosition;

public class GenericTrackingMenu {

	protected Canvas canvas;
	protected CircularMenuLayout menu;
	protected IConStateMachine interaction;

	public GenericTrackingMenu(Canvas canvas, JFrame frame, String[] items) {
		this(canvas, frame, 100, 30, items);
	}
	
	public GenericTrackingMenu(Canvas canvas, JFrame frame, int radius, int innerRadius, String[] items) {
		this.canvas = canvas;
		
		menu = new CircularMenuLayout(canvas, radius, innerRadius, true, items);
		menu.showMenu(new Point2D.Double(0, 0));
		
		interaction = new GenericTrackingMenuSM(canvas, menu);
		
		/*interaction = new IConStateMachine("trackingMenu", canvas) {
			MenuItem currentItem;
			Point2D lastPosition, startPosition;
			
			String[] properties = {"Radius"};
			
			@Override
			public String[] getProperties() {
				return properties;
			}
			
			public int getRadius() {
				return menu.getRadius();
			}
			
			public void setRadius(int r) {
				menu.setRadius(r);
			}
			
			public Class<? extends OutSlotEvent>[] getOutputTypes() {
				return new Class[] {CommandMove.class};
			}
			
			State outOfRange = new State() {
				Transition startTrackingInMenu = new SwitchOnTag(MenuItem.class, InRange.class, SWITCH_ON, ">> tracking") { };
				Transition startTrackingOutMenu = new SwitchOnPosition(InRange.class, SWITCH_ON, ">> tracking") {
					public void action() {
						menu.showMenu(getPoint());
					}
				};
			};
			State tracking = new State() {
				Transition stopTracking = new Switch(InRange.class, SWITCH_OFF, ">> outOfRange") {
					public void action() {
						menu.removeHighlight();
						menu.hideMenu();
					}
				};
				
				Transition startControl = new SwitchOnTag(MenuItem.class, Control.class, SWITCH_ON, ">> touching") {
					public void action() {
						currentItem = (MenuItem)getTag();
						lastPosition = getPoint();
						startPosition = lastPosition;
					}
				};
				
				// tracking menu does not move, highlight menu items
				Transition moveInMenu = new EventOnTag(MenuItem.class, Control.class) {
					public void action() {
						if(currentItem == getTag()) return;
						menu.removeHighlight();
						currentItem = (MenuItem)getTag();
						currentItem.setFillPaint(menu.getHiliteColor());
					}
				};
				Transition moveOutMenu = new EventOnPosition(Control.class) {
					double distanceFromMenuCenter;
					public boolean guard () {
						distanceFromMenuCenter = menu.getCurrentPosition().distance(getPoint());
						return distanceFromMenuCenter > menu.getRadius();
					}
					public void action() {
						double sinAngleToCenter = (getPoint().getY() - menu.getCurrentPosition().getY()) / distanceFromMenuCenter;
						double angleToCenter = Math.asin(sinAngleToCenter);
						double distanceToOutline = distanceFromMenuCenter - menu.getRadius();
						double dx = distanceToOutline * Math.cos(angleToCenter);
						if((getPoint().getX() - menu.getCurrentPosition().getX()) < 0) dx = -dx;
						double dy = distanceToOutline * sinAngleToCenter;
						
						menu.moveBy(dx, dy);
					}
				};
			};
			State touching = new State() {
				Transition stopControl = new SwitchOnPosition(Control.class, SWITCH_OFF, ">> tracking") {
					public void action() {
						menu.showMenu(getPoint());
						fireEvent(new CommandMove("", getPoint(), 0, 0, 0, 0));
					}
				};
				
				// tracking menu does not move
				Transition control = new EventOnPosition(Control.class) {
					public void action() {
						if (currentItem != null) {
							fireEvent(new CommandMove(currentItem.getName(), getPoint(), getPoint().getX() - lastPosition.getX(), getPoint().getY() - lastPosition.getY(), startPosition.getX(), startPosition.getY()));
							lastPosition = getPoint();
						}
					}
				};
			};
		};*/
		IConEnvironnement.addStateMachine(interaction, frame, canvas);
	}
	
	public IConStateMachine getInteraction() {
		return interaction;
	}
	
	public static void main(String[] args) {
		Canvas canvas = new Canvas (600, 400);
		canvas.setAntialiased(true);
		JFrame frame = new JFrame();
		new GenericTrackingMenu(canvas, frame, new String[] {"pan", "zoom", "pan", "zoom"});
		frame.getContentPane().add(canvas);
		frame.pack();
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		canvas.requestFocus();
		
		IConEnvironnement.start("tracking-menu-keyboard.ic");
		
	}
}
