package fr.lri.insitu.FlowStates.examples.simplePanZoom;

import java.awt.Color;
import java.awt.geom.Point2D;

import javax.swing.JFrame;

import fr.lri.insitu.FlowStates.IConEnvironnement;
import fr.lri.insitu.FlowStates.examples.graphicalEditor.ZoomableCanvas;
import fr.lri.insitu.FlowStates.examples.menus.TrackingMenu;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;

public class MainSimplePanZoom {

	private static boolean TRACKING_MENU = false;

	public static void main(String[] args) {
		ZoomableCanvas canvas = new ZoomableCanvas(300, 300);

		canvas.newRectangle(new Point2D.Double(20, 20), 30, 40).setFillPaint(Color.RED);
		canvas.newRectangle(new Point2D.Double(200, 200), 60, 40).setFillPaint(Color.YELLOW);
		canvas.newRectangle(new Point2D.Double(20, 200), 30, 40).setFillPaint(Color.GREEN);
		canvas.newRectangle(new Point2D.Double(200, 20), 30, 40).setFillPaint(Color.MAGENTA);

		JFrame frame = new JFrame();
		IConStateMachine pan = new PanInteraction("pan", canvas);
		IConStateMachine zoom = new ZoomInteraction("zoom", canvas);
		canvas.setAntialiased(true);

		IConEnvironnement.addStateMachine(pan, frame, canvas);
		IConEnvironnement.addStateMachine(zoom, frame, canvas);

		if(TRACKING_MENU) {
			TrackingMenu trackingMenu = new TrackingMenu(canvas, frame, 60, 20, new String[] {"pan", "zoom", "pan", "zoom"});
			IConEnvironnement.addStateMachine(trackingMenu, frame, canvas);
		}

		frame.getContentPane().add(canvas);
		frame.pack();
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		canvas.requestFocus();

		if(TRACKING_MENU)
			IConEnvironnement.start("IC files/simplePZ-TM.ic");
		else
			IConEnvironnement.start("IC files/simplePZ.ic");
	}

}


