package fr.lri.insitu.FlowStates;

import java.io.File;

import javax.swing.JFrame;

import fr.emn.inputeditor.JInputEditor;
import fr.emn.reactiveinput.Configuration;
import fr.emn.reactiveinput.DeviceFolder;
import fr.emn.reactiveinput.DeviceUtilities;
import fr.emn.reactiveinput.OpenContext;
import fr.emn.reactiveinput.devices.FRoot;
import fr.lri.insitu.FlowStates.device.DSMDevice;
import fr.lri.insitu.FlowStates.device.FSMFolder;
import fr.lri.insitu.FlowStates.sm.IConStateMachine;
import fr.lri.swingstates.canvas.Canvas;

public class IConEnvironnement {

	private static IConEnvironnement instance;

	private static FSMFolder folder;

	private static File confFile = null;
	private static JInputEditor dialog;

	private static Configuration conf;

	public static void addStateMachine(IConStateMachine sm, JFrame frame, Canvas canvas) {
		if (instance == null) {
			instance = new IConEnvironnement(frame);
		}
		DSMDevice proto = new DSMDevice(sm);
		folder.add(proto);
		DeviceUtilities.setPrototype(proto, proto);
		folder.refresh();
		dialog.getView().refreshAll();
	}

	public static void start() {
		start(null, "");
	}
	
	public static void start(String configurationFile) {
		start(null, configurationFile);
	}
	
	public static void start(JFrame frame) {
		start(frame, "");
	}
	
	public static void start(JFrame frame, String configurationFile) {
		if (instance == null) {
			instance = new IConEnvironnement(frame);
		}
		if (configurationFile != "") {
			confFile = new File(configurationFile);
			dialog.getView().load(dialog.getView().currentDesk(), confFile);
			// [3] Try to load configuration from a file
			//if(confFile != null) conf.load(confFile);
		}
		if (conf != null) {
			// [4] Open configuration
			conf.open();
			// [5] Start configuration
			conf.start();
		}		
	}
	
	private IConEnvironnement(JFrame frame) {
		// ** CREATE AND RUN CONFIGURATION **           
		folder = new FSMFolder("Application Devices");
		// [1] Create IconDraw Device Folder
		DeviceFolder root = new FRoot(folder);
		// [2] Create a new empty configuration
		OpenContext context;
		if (frame != null)
			context = new OpenContext(frame);
		else
			context = new OpenContext();
		conf = new Configuration(context, root);
		dialog = new JInputEditor(conf);
		dialog.setVisible(false);
	}
}
