package fr.lri.insitu.FlowStates.events;

import java.awt.Component;
import java.awt.geom.Point2D;
import java.util.LinkedList;
import java.util.List;

import fr.lri.swingstates.events.VirtualCanvasEvent;

public class IConPositionEvent extends VirtualCanvasEvent implements InSlotEvent, OutSlotEvent {
	
	private double screenX, screenY;
	private List<String> slotsSignal = new LinkedList<String>();
	
	public IConPositionEvent() {
		super(new Point2D.Double());
	}
	
	public IConPositionEvent(String n, Point2D pt) {
		super(n, pt);
	}
	
	public IConPositionEvent(Point2D pt) {
		super(pt);
	}

	public void setSlotX(double x) {
		screenX = x;
		getPoint().setLocation(x, getPoint().getY());
	}

	public void setSlotY(double y) {
		screenY = y;
		getPoint().setLocation(getPoint().getX(), y);
	}
	
	public double getSlotX() {
		return getPoint().getX();
	}

	public double getSlotY() {
		return getPoint().getY();
	}
	
	public double getScreenX() {
		return screenX;
	}

	public double getScreenY() {
		return screenY;
	}
	
	public void convertFromScreen(Component c) {
		if (c.isShowing())
			getPoint().setLocation(getSlotX()-c.getLocationOnScreen().getX(), getSlotY()-c.getLocationOnScreen().getY());
	}
	
	public boolean occurs() {
		return true;
	}
	
	public void slotHasSignal(String slotName) {
		if(!slotsSignal.contains(slotName)) slotsSignal.add(slotName);
	}
	
	public boolean hasSignal(String slotName) {
		return slotsSignal.contains(slotName.toLowerCase());
	}
	
}
