package fr.lri.insitu.FlowStates.transitions;

import java.util.EventObject;

import fr.lri.insitu.FlowStates.events.ICSwitchEvent;
import fr.lri.swingstates.sm.transitions.Event;

public class Switch extends Event {

	protected boolean on;
	
	public Switch(Class<? extends ICSwitchEvent> eventClass, boolean on, String outputState) {
		super(eventClass, outputState);
		this.on = on;
	}

	public Switch(Class<? extends ICSwitchEvent> eventClass, boolean on) {
		super(eventClass);
		this.on = on;
	}
	
	public boolean matches(EventObject eventObject) {
		if(!(eventObject instanceof ICSwitchEvent)) {
			return false;
		}
		ICSwitchEvent icSwitchEvent = (ICSwitchEvent)eventObject;
		if(icSwitchEvent.hasSwitchValueChanged() && icSwitchEvent.getSlotOn() == on)
			return super.matches(eventObject);
		else
			return false;
	}
	
	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		String switchValue = on ? "SWITCH_ON" : "SWITCH_OFF";
		if(classEvent != null) return "Switch("+classEvent.getSimpleName()+".class"+", "+ switchValue+")";
		else return "Switch("+event+", "+ switchValue+")";
	}

}
