package fr.lri.insitu.FlowStates.transitions;

import java.util.EventObject;

import fr.lri.insitu.FlowStates.events.ICSwitchEvent;
import fr.lri.swingstates.canvas.transitions.EventOnShape;

public class SwitchOnShape extends EventOnShape {

	protected boolean on;
	
	public SwitchOnShape(Class<? extends ICSwitchEvent> eventClass, boolean on, String outState) {
		super(eventClass, outState);
		this.on = on;
	}

	public SwitchOnShape(Class<? extends ICSwitchEvent> eventClass, boolean on) {
		super(eventClass);
		this.on = on;
	}
	
	public boolean matches(EventObject eventObject) {
		if(!(eventObject instanceof ICSwitchEvent)) {
			return false;
		}
		ICSwitchEvent icSwitchEvent = (ICSwitchEvent)eventObject;
		if(icSwitchEvent.hasSwitchValueChanged() && icSwitchEvent.getSlotOn() == on)
			return super.matches(eventObject);
		else
			return false;
	}
	
	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		String switchValue = on ? "SWITCH_ON" : "SWITCH_OFF";
		if (classEvent != null)
			return "SwitchOnShape(" + classEvent.getSimpleName() + ".class"+", "+ switchValue+")";
		else
			return "SwitchOnShape(" + event +", "+ switchValue+")";
	}

}
